import os
import subprocess

# Check and install the required libraries
def check_and_install_libraries():
    required_libraries = ["docx2pdf"]

    for lib in required_libraries:
        try:
            # Check if the library is already installed
            __import__(lib)
        except ImportError:
            print(f"Installing {lib}...")
            subprocess.call(["pip", "install", lib])

# Function to convert .docx files to PDF
def convert_directory_to_pdf(input_directory, output_directory):
    for root, dirs, files in os.walk(input_directory):
        for file in files:
            if file.endswith(".docx"):
                docx_file = os.path.join(root, file)
                relative_path = os.path.relpath(docx_file, input_directory)
                output_subdirectory = os.path.join(output_directory, os.path.dirname(relative_path))
                os.makedirs(output_subdirectory, exist_ok=True)
                output_file = os.path.join(output_subdirectory, os.path.splitext(file)[0] + ".pdf")

                # Convert .docx to PDF
                convert(docx_file, output_file)

                print(f"Converted {docx_file} to {output_file}")

if __name__ == "__main__":
    # Check and install required libraries
    check_and_install_libraries()

    # Specify the input and output directory paths
    input_directory = "input"
    output_directory = "output-pdf"

    convert_directory_to_pdf(input_directory, output_directory)
